
// BME280 - czujnik cisnienia, temperatury i wilgotności względnej
//  Wykorzystamy biblioteki: BME280I2C   Wire  LiquidCrystal 
// dołaczamy biblioteki - klasy:
#include <BME280I2C.h> //obsługa BME przez łacze I2C
#include <Wire.h>          // obsługa TWI = I2C
#include <LiquidCrystal.h>  //obsługa wyświetlacza LCD
//tworzymy i konfigurujemy obiekt wyświetlacz o nazwie: "lcd"
LiquidCrystal lcd(2, 3, 4, 5, 6, 7);
//tworzymy obiekt (BME280) o nazwie "czujnik" z domyślnymi parametrami
BME280I2C czujnik;    // Default : forced mode, standby time = 1000 ms
// Oversampling = pressure ×1, temperature ×1, humidity ×1, filter off,
//teraz tworzymy trzy zmienne globalne typu float dla wyników pomiaru:
float tmp, wilg, cis;

void setup() {  //jednorazowo incjalizujemy obiekty:
 lcd.begin(16, 2); // wyświelacz
 Wire.begin(); // łącze TWI = I2C
 // czujnik - i czekamy, aż czujnik będzie prawidłowo podłaczony:
  while (!czujnik.begin())  //jeśli brak kontaktu z czujnikiem:
 { lcd.clear(); lcd.print("brak kontaktu"); lcd.setCursor(0, 1);
 lcd.print("z sensorem");      delay(2000);    }
 lcd.clear(); //czyścimy wyświetlacz i sprawdzamy czujnik:
 switch (czujnik.chipModel())     {
  case BME280::ChipModel_BME280:
   lcd.print("Sukces!"); lcd.setCursor(0, 1);
   lcd.print("Jest czujnik BME280! ");     break;
  case BME280::ChipModel_BMP280:
   lcd.print("znalazłem BMP280"); lcd.setCursor(0, 1);
   lcd.print("Bez pomiaru wilgotnosci");   break;
  default:
   lcd.println("Blad! Nieznany czujnik!");     }
delay(5000);   }

void loop() { //w petli co około 1 sekundę:
// odczytujemy zmierzone wartości do zmiennych: 
//albo ustawiamy jednostki temperatury i ciśnienia
//  BME280::TempUnit tempUnit(BME280::TempUnit_Celsius);
//  BME280::PresUnit presUnit(BME280::PresUnit_hPa);
//  czujnik.read(cis, tmp, wilg, tempUnit, presUnit);
//albo "idziemy na skróty":
  czujnik.read(cis, tmp, wilg, 0, 1); //cisnienie w hPa
// czujnik.read(cis, tmp, wilg, 0, 0); // //cisnienie w Pa
// czujnik.read(cis, tmp, wilg); // //cisnienie w Pa
// albo "czytamy pojedynczo":
   // tmp = czujnik.temp(0);
   // cis = czujnik.pres(1);
   // wilg = czujnik.hum();  
//i wyświetlamy wyniki na wyświetlaczu LCD:
  lcd.clear(); lcd.print("T="); lcd.print(tmp, 1);
  lcd.write(223); lcd.print('C');  //symbol stopnia
  lcd.print(" RH="); lcd.print(wilg, 0); lcd.print('%');
  lcd.setCursor(0, 1); //w dolnej linii:
  lcd.print("Cisnienie"); lcd.print(cis, 0); lcd.print("hPa");
  delay(1000);  } // koniec pętli

/*
#include <EnvironmentCalculations.h>
#include <BME280I2C.h>
#include <Wire.h>       
#include <LiquidCrystal.h>
LiquidCrystal lcd(2, 3, 4, 5, 6, 7);
// tworzymy obiekt o nazwie "czujnik" z domyślnymi parametrami
BME280I2C czujnik;    // Default : forced mode, standby time = 1000 ms
// Oversampling = pressure ×1, temperature ×1, humidity ×1, filter off,
float tmp, wilg, cis; // tworzymy zmienne globalne typu float

void setup() {  //incjalizujemy obiekty;
 lcd.begin(16, 2); Wire.begin(); czujnik.begin();  }

void loop() { //w petli co około 1 sekundę:
// odczytujemy zmierzone wartości do zmiennych: 
tmp = czujnik.temp(0);
wilg = czujnik.hum();
// i obliczamy temperaturę punktu rosy (granicę wykraplania wody z powietrza)
// EnvironmentCalculations::TempUnit     envTempUnit =  EnvironmentCalculations::TempUnit_Celsius;
// float dewPoint = EnvironmentCalculations::DewPoint(tmp, wilg, envTempUnit);
// albo prosciej:
float dewPoint = EnvironmentCalculations::DewPoint(tmp, wilg, 0); // w ° Celsjusza
//float dewPoint = EnvironmentCalculations::DewPoint(tmp, wilg, 1); // w ° Fahrenheita
//float dewPoint = EnvironmentCalculations::DewPoint(tmp, wilg); // w ° Fahrenheita
// float aH = EnvironmentCalculations::AbsoluteHumidity (tmp, wilg, 0);
//wyświetlamy wyniki na wyświetlaczu LCD:
  lcd.clear(); lcd.print("T="); lcd.print(tmp, 1);
  lcd.write(223); lcd.print('C');  //symbol stopnia
  lcd.print(" RH="); lcd.print(wilg, 0); lcd.print('%');
  lcd.setCursor(0, 1); //w dolnej linii:
  lcd.print("PunktRosy:"); lcd.print(dewPoint, 1);   lcd.write(223); lcd.print('C'); 
//  lcd.print("AH"); lcd.print(aH, 1);   lcd.print("g/m3"); 
// lcd.print(" P"); lcd.print(cis, 0); lcd.print("hPa");
  delay(1000);  }


/*
#include <EnvironmentCalculations.h>
#include <BME280I2C.h>
#include <Wire.h>       
#include <LiquidCrystal.h>
LiquidCrystal lcd(2, 3, 4, 5, 6, 7);
// tworzymy obiekt o nazwie "czujnik" z domyślnymi parametrami
BME280I2C czujnik;    // Default : forced mode, standby time = 1000 ms
// Oversampling = pressure ×1, temperature ×1, humidity ×1, filter off,
float tmp, wilg, cis; // tworzymy zmienne globalne typu float

void setup() {  //incjalizujemy obiekty;
 lcd.begin(16, 2); Wire.begin(); czujnik.begin();  }

void loop() { //w petli co około 1 sekundę:
// odczytujemy zmierzone wartości do zmiennych: 
tmp = czujnik.temp() ;
wilg = czujnik.hum();
// i obliczamy temperaturę punktu rosy (granicę wykraplania wody z powietrza)
// EnvironmentCalculations::TempUnit     envTempUnit =  EnvironmentCalculations::TempUnit_Celsius;
// float dewPoint = EnvironmentCalculations::DewPoint(tmp, wilg, envTempUnit);
// albo prosciej:
//float dewPoint = EnvironmentCalculations::DewPoint(tmp, wilg, 0); // w ° Celsjusza
float dewPoint = EnvironmentCalculations::DewPoint(tmp, wilg, 1); // w ° Fahrenheita
//float dewPoint = EnvironmentCalculations::DewPoint(tmp, wilg); // w ° Fahrenheita
float aH = EnvironmentCalculations::AbsoluteHumidity (tmp, wilg, 0);
//wyświetlamy wyniki na wyświetlaczu LCD:
  lcd.clear(); lcd.print("T="); lcd.print(tmp, 1);
  lcd.write(223); lcd.print('C');  //symbol stopnia
  lcd.print(" RH="); lcd.print(wilg, 0); lcd.print('%');
  lcd.setCursor(0, 1); //w dolnej linii:
  lcd.print("P"); lcd.print(dewPoint, 1);   lcd.write(223); lcd.print('C'); 
 lcd.print("AH"); lcd.print(aH, 1);   lcd.print("g/m3"); 
// lcd.print(" P"); lcd.print(cis, 0); lcd.print("hPa");
  delay(1000);  }

 */








/*
 // dołaczamy biblioteki - klasy:
#include <BME280I2C.h> //obsługa BME przez łacze I2C
#include <Wire.h>          // obsługa TWI = I2C
#include <LiquidCrystal.h>  //obsługa wyświetlacza LCD
//tworzymy i konfigurujemy obiekt wyświetlacz o nazwie: "lcd"
LiquidCrystal lcd(2, 3, 4, 5, 6, 7);
// tworzymy obiekt o nazwie "czujnik" z domyślnymi parametrami
BME280I2C czujnik;    // Default : forced mode, standby time = 1000 ms
// Oversampling = pressure ×1, temperature ×1, humidity ×1, filter off,
//teraz tworzymy zmienne globalne typu float:
float temp(NAN), hum(NAN), pres(NAN);
// float temp(NAN), hum(NAN), pres(NAN);
void setup() {  //jednorazowo
 lcd.begin(16, 2); //incjalizyjemy wyświelacz
 Wire.begin(); //inicjalizujemy łącze TWI = I2C
 //i czekamy, aż czujnik będzie prawidłowo podłaczony:
  while (!czujnik.begin())  //jeśli brak kontaktu z czujnikiem:
 { lcd.clear(); lcd.print("brak kontaktu"); lcd.setCursor(0, 1);
 lcd.print("z sensorem");      delay(2000);    }
 lcd.clear(); //czyścimy wyświetlacz i sprawdzamy czujnik:
 switch (czujnik.chipModel())     {
  case BME280::ChipModel_BME280:
   lcd.print("Sukces!"); lcd.setCursor(0, 1);
   lcd.print("Jest czujnik BME280! ");     break;
  case BME280::ChipModel_BMP280:
   lcd.print("znalazłem BMP280"); lcd.setCursor(0, 1);
   lcd.print("Bez pomiaru wilgotnosci");   break;
  default:
   lcd.println("Blad! Nieznany czujnik!");     }
delay(4000);   }

void loop() { //w petli co około 1 sekundę:
//ustawiamy jednostki temperatury i ciśnienia
  BME280::TempUnit tempUnit(BME280::TempUnit_Celsius);
  BME280::PresUnit presUnit(BME280::PresUnit_hPa);
// odczytujemy zmierzonewartości do zmiennych:
  czujnik.read(pres, tmp, hum, tempUnit, presUnit);
//wyświetlamy wyniki na wyświetlaczu LCD:
  lcd.clear(); lcd.print("T="); lcd.print(tmp, 1);
  lcd.write(223); lcd.print('C');  //symbol stopnia
  lcd.print(" RH="); lcd.print(hum, 0); lcd.print('%');
  lcd.setCursor(0, 1); //w dolnej linii:
  lcd.print("Cisnienie"); lcd.print(pres, 0); lcd.print("hPa");
  delay(2000);  }
*/

